
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ticket_commentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ticket_comments = await db.ticket_comments.create(
            {
                id: data.id || undefined,
        
        visibility: data.visibility
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        posted_at: data.posted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ticket_comments.setTenant( data.tenant || null, {
            transaction,
        });
        
        await ticket_comments.setTicket( data.ticket || null, {
            transaction,
        });
        
        await ticket_comments.setAuthor( data.author || null, {
            transaction,
        });
        
        await ticket_comments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ticket_comments.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ticket_comments.id,
            },
            data.attachments,
            options,
        );
        

        return ticket_comments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ticket_commentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                visibility: item.visibility
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                posted_at: item.posted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ticket_comments = await db.ticket_comments.bulkCreate(ticket_commentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < ticket_comments.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.ticket_comments.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: ticket_comments[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return ticket_comments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const ticket_comments = await db.ticket_comments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.visibility !== undefined) updatePayload.visibility = data.visibility;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.posted_at !== undefined) updatePayload.posted_at = data.posted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await ticket_comments.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await ticket_comments.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.ticket !== undefined) {
            await ticket_comments.setTicket(
              
              data.ticket,
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await ticket_comments.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await ticket_comments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ticket_comments.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ticket_comments.id,
            },
            data.attachments,
            options,
        );
        

        return ticket_comments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ticket_comments = await db.ticket_comments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (ticket_comments.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ticket_comments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ticket_comments) {
                await record.destroy({transaction});
            }
        });


        return ticket_comments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ticket_comments = await db.ticket_comments.findByPk(id, options);

        if (!ticket_comments) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await ticket_comments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ticket_comments.destroy({
            transaction
        });

        return ticket_comments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ticket_comments = await db.ticket_comments.findOne(
            { where },
            { transaction },
        );

        if (!ticket_comments) {
            return ticket_comments;
        }

        const output = ticket_comments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await ticket_comments.getTenant({
            transaction
        });
        
        
        output.ticket = await ticket_comments.getTicket({
            transaction
        });
        
        
        output.author = await ticket_comments.getAuthor({
            transaction
        });
        
        
        output.attachments = await ticket_comments.getAttachments({
            transaction
        });
        
        
        output.organizations = await ticket_comments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.support_tickets,
        as: 'ticket',
        
        where: filter.ticket ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ticket.split('|').map(term => Utils.uuid(term)) } },
            {
              ticket_number: {
                [Op.or]: filter.ticket.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ticket_comments',
                        'body',
                        filter.body,
                    ),
                };
            }
            

            
            

            
            if (filter.posted_atRange) {
                const [start, end] = filter.posted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    posted_at: {
                    ...where.posted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.visibility) {
                where = {
                    ...where,
                visibility: filter.visibility,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ticket_comments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ticket_comments',
                        'body',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ticket_comments.findAll({
            attributes: [ 'id', 'body' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['body', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.body,
        }));
    }

    
};

